package net.sf.freetime;

/**
 * Useful utility methods.
 *
 * @author Robin Rawson-Tetley
 */
public abstract class Util {

	/**
     * Splits a string by a particular char and returns an array of
     * strings. If there are no occurrences of the split char, the
     * original string is returned in an array of 1 item.
     * @param splitstring The string to be split
     * @param splitchar The char to split on
     * @return An array of strings
     */
	public static String[] split(String splitstring, String splitchar) {
		
		splitstring = splitstring.trim();
        
        // If there is only one element, just return that
        if (splitstring.indexOf(splitchar) == -1) {
            String[] rets = new String[1];
            rets[0] = splitstring;
            return rets;
        }
        
        // Find how many there are
        int tot = 0;
        int lpos = splitstring.indexOf(splitchar);
        while (lpos != -1) {
            tot++;
            lpos = splitstring.indexOf(splitchar, lpos + 1);
        }
        tot++;
        
        // Create our new array
        String[] rets = new String[tot];
        tot = 0;
        lpos = 0;
        int spos = splitstring.indexOf(splitchar);
        while (spos != -1) {
            // Add into the array
            rets[tot] = splitstring.substring(lpos, spos);
            tot++;
            lpos = spos + 1;
            spos = splitstring.indexOf(splitchar, lpos);
        }
        
        // Include last word
        rets[tot] = splitstring.substring(lpos, splitstring.length());
        
        // Return it
        return rets;
	}

}
