/*
 * Created on Aug 30, 2005
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.sf.freetime.dto;

import net.sf.freetime.CSVRow;

public class Expense {

	protected String type = "EXP";
	protected String expenseTypeCode = "";
	protected String expenseTypeDescription = "";
	protected String date = "";
	protected String project = "";
	protected String quantity = "";
	protected String amount = "";
	protected String vatCode = "";
	protected String vatDescription = "";
	protected String employeeCode = "";
	protected String employeeForename = "";
	protected String employeeSurname = "";
	protected String phaseCode = "";
	protected String taskCode = "";
	protected String notes = "";
	protected String sequence = "";
	
	public Expense() {
	}
	
	/**
	 * @return Returns the amount.
	 */
	public String getAmount() {
		return amount;
	}

	/**
	 * @param amount The amount to set.
	 */
	public void setAmount(String amount) {
		this.amount = amount;
	}

	/**
	 * @return Returns the date.
	 */
	public String getDate() {
		return date;
	}

	/**
	 * @param date The date to set.
	 */
	public void setDate(String date) {
		this.date = date;
	}

	/**
	 * @return Returns the employeeCode.
	 */
	public String getEmployeeCode() {
		return employeeCode;
	}

	/**
	 * @param employeeCode The employeeCode to set.
	 */
	public void setEmployeeCode(String employeeCode) {
		this.employeeCode = employeeCode;
	}

	/**
	 * @return Returns the employeeForename.
	 */
	public String getEmployeeForename() {
		return employeeForename;
	}

	/**
	 * @param employeeForename The employeeForename to set.
	 */
	public void setEmployeeForename(String employeeForename) {
		this.employeeForename = employeeForename;
	}

	/**
	 * @return Returns the employeeSurname.
	 */
	public String getEmployeeSurname() {
		return employeeSurname;
	}

	/**
	 * @param employeeSurname The employeeSurname to set.
	 */
	public void setEmployeeSurname(String employeeSurname) {
		this.employeeSurname = employeeSurname;
	}

	/**
	 * @return Returns the expenseTypeCode.
	 */
	public String getExpenseTypeCode() {
		return expenseTypeCode;
	}

	/**
	 * @param expenseTypeCode The expenseTypeCode to set.
	 */
	public void setExpenseTypeCode(String expenseTypeCode) {
		this.expenseTypeCode = expenseTypeCode;
	}

	/**
	 * @return Returns the expenseTypeDescription.
	 */
	public String getExpenseTypeDescription() {
		return expenseTypeDescription;
	}

	/**
	 * @param expenseTypeDescription The expenseTypeDescription to set.
	 */
	public void setExpenseTypeDescription(String expenseTypeDescription) {
		this.expenseTypeDescription = expenseTypeDescription;
	}

	/**
	 * @return Returns the notes.
	 */
	public String getNotes() {
		return notes;
	}

	/**
	 * @param notes The notes to set.
	 */
	public void setNotes(String notes) {
		this.notes = notes;
	}

	/**
	 * @return Returns the phaseCode.
	 */
	public String getPhaseCode() {
		return phaseCode;
	}

	/**
	 * @param phaseCode The phaseCode to set.
	 */
	public void setPhaseCode(String phaseCode) {
		this.phaseCode = phaseCode;
	}

	/**
	 * @return Returns the project.
	 */
	public String getProject() {
		return project;
	}

	/**
	 * @param project The project to set.
	 */
	public void setProject(String project) {
		this.project = project;
	}

	/**
	 * @return Returns the quantity.
	 */
	public String getQuantity() {
		return quantity;
	}

	/**
	 * @param quantity The quantity to set.
	 */
	public void setQuantity(String quantity) {
		this.quantity = quantity;
	}

	/**
	 * @return Returns the sequence.
	 */
	public String getSequence() {
		return sequence;
	}

	/**
	 * @param sequence The sequence to set.
	 */
	public void setSequence(String sequence) {
		this.sequence = sequence;
	}

	/**
	 * @return Returns the taskCode.
	 */
	public String getTaskCode() {
		return taskCode;
	}

	/**
	 * @param taskCode The taskCode to set.
	 */
	public void setTaskCode(String taskCode) {
		this.taskCode = taskCode;
	}

	/**
	 * @return Returns the type.
	 */
	public String getType() {
		return type;
	}

	/**
	 * @param type The type to set.
	 */
	public void setType(String type) {
		this.type = type;
	}

	/**
	 * @return Returns the vatCode.
	 */
	public String getVatCode() {
		return vatCode;
	}

	/**
	 * @param vatCode The vatCode to set.
	 */
	public void setVatCode(String vatCode) {
		this.vatCode = vatCode;
	}

	/**
	 * @return Returns the vatDescription.
	 */
	public String getVatDescription() {
		return vatDescription;
	}

	/**
	 * @param vatDescription The vatDescription to set.
	 */
	public void setVatDescription(String vatDescription) {
		this.vatDescription = vatDescription;
	}

	/** Parses from an EXP CSVRow */
	public void parse(CSVRow r) {
		setType(r.getValue(0));
		setExpenseTypeCode(r.getValue(1));
		setExpenseTypeDescription(r.getValue(2));
		setDate(r.getValue(3));
		setProject(r.getValue(4));
		setQuantity(r.getValue(5));
		setAmount(r.getValue(6));
		setVatCode(r.getValue(7));
		setVatDescription(r.getValue(8));
		setEmployeeCode(r.getValue(10));
		setEmployeeForename(r.getValue(11));
		setEmployeeSurname(r.getValue(12));
		setPhaseCode(r.getValue(13));
		setTaskCode(r.getValue(14));
		setNotes(r.getValue(15));
		setSequence(r.getValue(16));
	}
	
	/**
	 * Returns the data in this expense as a CSVRow for saving
	 * in the data file.
	 */
	public CSVRow toCSVRow() {
		
		CSVRow r = new CSVRow(23);
		r.putValue(0, "EXP");
		r.putValue(1, getExpenseTypeCode());
		r.putValue(2, getExpenseTypeDescription());
		r.putValue(3, getDate());
		r.putValue(4, getProject());
		r.putValue(5, getQuantity());
		r.putValue(6, getAmount());
		
		r.putValue(7, getVatCode());
		r.putValue(8, getVatDescription());
		r.putValue(9, ""); // Unknown 
		
		r.putValue(10, getEmployeeCode());
		r.putValue(11, getEmployeeForename());
		r.putValue(12, getEmployeeSurname());
		r.putValue(13, getPhaseCode());
		r.putValue(14, getTaskCode());
		r.putValue(15, getNotes());
		r.putValue(16, getSequence());
		
		// This value is always 0 in capture
		r.putValue(17, "0");
		
		// Don't know what this value is - seen 4 on non-mileage
		// and 8 on mileage
		if (getAmount().equals(""))
			r.putValue(18, "8");
		else
			r.putValue(18, "4");
		
		// The last values were all empty in my
		// captured samples
		r.putValue(19, "");
		r.putValue(20, "");
		r.putValue(21, "");
		r.putValue(22, "");
		
		return r;
	}
	
	public String toString() {
		return toCSVRow().toString();
	}

}
